/*
  Scrivere una funzione 
 
  int * minimo(int a[], int len) 

  che, dato un array a di lunghezza len, restituisca un puntatore 
  al minimo valore contenuto in a. 

  Scrivere un programma che utilizzi rand() per la generazione di un 
  array di 10 elementi interi casuali in [0,100] 
  e provare la funzione stampando il valore del minimo e il suo indirizzo.
 
*/

#include <stdlib.h> // necessaria per rand() and srand()
#include <stdio.h>

#define ARRAYLEN (10)
#define INTMAX (100)

int *minimo(int a[], int len)  { 

   int i, min = 0; // min conterrà la posizione del minimo in a[0, i]

   for(i = 1; i < len; i++) 
	if( a[i] < a[min] ) min = i;

  return a + min;

}

/* Versione alternativa con più aritmetica dei puntatori. 
Qual è la differenza? Cosa succede a p nel ciclo for? */
int *minimo1(int a[], int len) {

  int *p, *res = a;

  for (p = a; p < a + len; p++)
        if ( *p < *res ) res = p;

  return res;

}

int main() {

    int *min, i, a[ARRAYLEN]; 
    
    srand( time(NULL) );
   
    for(i = 0; i < ARRAYLEN; i++) 
	    a[i] = rand()%(INTMAX+1); // genera un numero casuale in [0, INTMAX]

    min = minimo1(a, ARRAYLEN);
    printf("%d %p\n", *min, min);

    return 0;
}